sbit rs at rd3_bit; sbit en at rd2_bit; sbit d4 at rd1_bit; sbit d5 at rd0_bit; sbit d6 at rc1_bit; sbit d7 at rc2_bit; // 

unsigned char ru[64] absolute 0x500; //      HID-USB
unsigned char wu[64] absolute 0x540; //      HID-USB
unsigned gr1,mg1,mg2,mg3,mg4,mv1,mv2,mv3,mv4;
//gr1-   /  
//mg1-   / 
//mg2-   / RGB 
//mg3,mg4-   / 
//mv1- / 
//mv2- / RGB 
//mv3,mv4- / 
char tx1[4],tx2[8];
//tx1[4]-      
//tx2[8]-    
unsigned short mnu,i1,rg1,rg2,rg3,rg4,np1,np2,np3,np4,pp1,pp2,pp3,pp4,ps1;
//mnu- 
//i1-  
//rg1-   
//rg2-   RGB 
//rg3,rg4-   
//np1-   
//np2-   RGB 
//np3,np4-   
//pp1-   
//pp2-   RGB 
//pp3,pp4-   
//ps1-   
unsigned short rr1,gg1,bb1,rr2,gg2,bb2,ms1,ms2,yr1,yr2,dd1[3],dd2[3];
//rr1,gg1,bb1,rr2,bb2,gg2-   ,   
//ms1,ms2-     0
//yr1,yr2-   
//dd1[3],dd2[3]-   /  
unsigned short dt1[128],dt2[128],dt3[192],dt4[192],sh1,sh2,sh3,sh4,kp1,kp2,kp3,kp4;
//dt1[128]-     
//dt2[128]-     RGB 
//dt3[192],dt4[192]-     
//sh1-   
//sh2-   RGB 
//sh3,sh4-   
//kp1-   
//kp2-   RGB 
//kp3,kp4-   
bit k1,k2,k3,kn1,kn2,kn3; //  
bit ep1,st1,ps2,rgb1,vk1,vk2,vk3,vk4,v12;
//ep1-    EEPROM 
//st1-  
//ps2-  
//rgb1-   rgb 
//vk1,vk2,vk3,vk4-   
//v12-     

void interrupt() //    0
{
if (tmr0if_bit==1)
{
ms1++; tmr0if_bit=0; tmr0l=154;
if (rgb1==1)
{
rr1++; if (rr1<(100-rr2)) porta.b0=0; else porta.b0=1; if (rr1>100) rr1=0; //  
gg1++; if (gg1<(100-gg2)) porta.b1=0; else porta.b1=1; if (gg1>100) gg1=0; //  
bb1++; if (bb1<(100-bb2)) porta.b2=0; else porta.b2=1; if (bb1>100) bb1=0; //  
}
yr1++; if (yr1<(100-yr2)) portb.b3=0; else portb.b3=1; if (yr1>100) yr1=0; // 
}
}

const char st0[]= //    
{
0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x1f,0x00, //" "   ( 0x00)
0x04,0x0e,0x1f,0x00,0x04,0x0e,0x1f,0x00, //" "       ( 0x01)
0x1f,0x0e,0x04,0x00,0x04,0x0e,0x1f,0x00, //" "   ( 0x02)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, //" "    ( 0x03)
0x1e,0x01,0x01,0x0e,0x01,0x01,0x1e,0x00, // ""          ( 0x04)
0x00,0x00,0x10,0x10,0x1f,0x11,0x1e,0x00, // ""          ( 0x05)
0x00,0x00,0x1e,0x11,0x1e,0x11,0x1e,0x00  // ""          ( 0x06)
};

void d10us() {delay_us(10);} void d5ms() {delay_ms(5);}
void indwr(unsigned short sm,unsigned short dt) //   
{
rs=dt; //rs=0- , rs=1- 
d7=sm>>7; d6=sm>>6; d5=sm>>5; d4=sm>>4; d10us();en=1;d10us();en=0;
d7=sm>>3; d6=sm>>2; d5=sm>>1; d4=sm>>0; d10us();en=1;d10us();en=0;
d7=1; d6=1; d5=1; d4=1; d10us();d10us();
}

void indin() // 
{
d5ms();d5ms();d5ms();
for (i1=0; i1<3; i1++) {d7=0;d6=0;d5=1;d4=1; d10us();en=1;d10us();en=0; d5ms();} d4=0; d10us();en=1;d10us();en=0; //    
indwr(0x28,0); //   4 , 2 , 58   ( function set)
indwr(0x0c,0); // ,   ( display on/off control)
indwr(0x01,0); d5ms(); //  DDRAM
indwr(0x06,0); //  ,    DDRAM,  ( entry mode set)
for (i1=0; i1<56; i1++) {indwr(0x40+i1,0); indwr(st0[i1],1);} //  CGRAM    
}

void stroka(unsigned short nm2) {if (st1==1) {nm2=(nm2-1)*40; for (i1=0; i1<8; i1++) {indwr(0x80+i1+nm2,0); indwr(tx2[i1],1);}}} //   

void but() // 
{
if (re3_bit==1) k1=1; if (re3_bit==0 && k1==1) {k1=0; kn1=1;} //++
if (rb7_bit==1) k2=1; if (rb7_bit==0 && k2==1) {k2=0; kn2=1;} /// /  
if (rc0_bit==1) k3=1; if (rc0_bit==0 && k3==1) {k3=0; kn3=1;} //--
}

void eepromr(unsigned nm1,unsigned short nm2) //   24lc256
{
i2c1_start();          //    i2c
i2c1_wr(0xa0);         //1010+ 24lc256(000)+   (0)
i2c1_wr(nm1>>8);       // ( )      
i2c1_wr(nm1<<0);       // ( )      
i2c1_repeated_start(); //     i2c
i2c1_wr(0xa1);         //1010+ 24lc256(000)+  (1)
if (nm2==0) {for (i1=0; i1<127; i1++) dt1[i1]=i2c1_rd(1); dt1[127]=i2c1_rd(0);} // 
if (nm2==1) {for (i1=0; i1<127; i1++) dt2[i1]=i2c1_rd(1); dt2[127]=i2c1_rd(0);} // RGB 
if (nm2==2) {for (i1=0; i1<191; i1++) dt3[i1]=i2c1_rd(1); dt3[191]=i2c1_rd(0);} // 1 
if (nm2==3) {for (i1=0; i1<191; i1++) dt4[i1]=i2c1_rd(1); dt4[191]=i2c1_rd(0);} // 2 
i2c1_stop();           //    i2c
}

void zaps() //  24lc256   
{
st1=1; ps2=1; portc.b6=1;
tx2[0]=0x20;tx2[1]=0x04;tx2[2]=0x61;tx2[3]=0xbe;tx2[4]=0xb8;tx2[5]=0x63;tx2[6]=0x05;tx2[7]=0x20; stroka(1);
tx2[0]=0x06;tx2[1]=0x20;tx2[2]=0x45;tx2[3]=0x45;tx2[4]=0x50;tx2[5]=0x52;tx2[6]=0x4f;tx2[7]=0x4d; stroka(2);
while(mv1<32000)
{
asm clrwdt; delay_ms(4); usb_polling_proc(); hid_read();
i2c1_start();    //    i2c
i2c1_wr(0xa0);   //1010+ 24lc256(000)+   (0)
i2c1_wr(mv1>>8); // ( )      
i2c1_wr(mv1<<0); // ( )      
for (i1=0; i1<64; i1++) i2c1_wr(ru[i1]);
i2c1_stop();     //    i2c
mv1=mv1+64; mv2++; wu[0]=12; wu[1]=12; wu[2]=mv2>>8; wu[3]=mv2<<0; hid_write(&wu,64);
}
mv1=0; mv2=0;
}

void chtn() //     24lc256
{
st1=1; ps2=1; portc.b6=1;
tx2[0]=0xa8;tx2[1]=0x65;tx2[2]=0x70;tx2[3]=0x65;tx2[4]=0xe3;tx2[5]=0x61;tx2[6]=0xc0;tx2[7]=0x61; stroka(1);
tx2[0]=0x63;tx2[1]=0x20;tx2[2]=0x45;tx2[3]=0x45;tx2[4]=0x50;tx2[5]=0x52;tx2[6]=0x4f;tx2[7]=0x4d; stroka(2);
delay_ms(10);
while(mv1<32000)
{
asm clrwdt; usb_polling_proc();
i2c1_start();          //    i2c
i2c1_wr(0xa0);         //1010+ 24lc256(000)+   (0)
i2c1_wr(mv1>>8);       // ( )      
i2c1_wr(mv1<<0);       // ( )      
i2c1_repeated_start(); //     i2c
i2c1_wr(0xa1);         //1010+ 24lc256(000)+  (1)
for (i1=0; i1<63; i1++) wu[i1]=i2c1_rd(1); wu[63]=i2c1_rd(0);
i2c1_stop();           //    i2c
hid_write(&wu,64); mv1=mv1+64;
}
mv1=0;
}

void vklg() /// 
{
portd.b6=gr1>>0; portd.b7=gr1>>1; portb.b2=gr1>>2; portb.b4=gr1>>3; portb.b6=gr1>>4;
porte.b1=gr1>>5; porte.b0=gr1>>6; porta.b5=gr1>>7; porta.b4=gr1>>8; porta.b3=gr1>>9;
}

void vkl12() /// 
{
portd.b5=1;
for (i1=0; i1<8; i1++) {portc.b7=(dd1[0]>>i1) & 1; porte.b2=(dd2[0]>>i1) & 1; portb.b5=~portb.b5; portb.b5=1; delay_us(1);}
for (i1=0; i1<8; i1++) {portc.b7=(dd1[1]>>i1) & 1; porte.b2=(dd2[1]>>i1) & 1; portb.b5=~portb.b5; portb.b5=1; delay_us(1);}
for (i1=0; i1<8; i1++) {portc.b7=(dd1[2]>>i1) & 1; porte.b2=(dd2[2]>>i1) & 1; portb.b5=~portb.b5; portb.b5=1; delay_us(1);}
portd.b4=~portd.b4; portd.b4=0;
}

void vik1() {gr1=0; vklg();                                mg1=1000; mv1=0; sh1=0; pp1=0; vk1=1; delay_ms(5);} // 
void vik2() {rr2=100; gg2=100; bb2=100;                    mg2=1000; mv2=0; sh2=0; pp2=0; vk2=1; delay_ms(5);} // RGB 
void vik3() {dd1[0]=0; dd1[1]=0; dd1[2]=0; vkl12(); v12=1; mg3=1000; mv3=0; sh3=0; pp3=0; vk3=1; delay_ms(5);} // 1 
void vik4() {dd2[0]=0; dd2[1]=0; dd2[2]=0; vkl12(); v12=1; mg4=1000; mv4=0; sh4=0; pp4=0; vk4=1; delay_ms(5);} // 2 

void menu1() //  
{
tx2[0]=0x31;tx2[1]=0x30;tx2[2]=0x20;tx2[3]=0x20;tx2[4]=0x20;tx2[5]=0x20;tx2[6]=0x31;tx2[7]=0x30; stroka(1);
if (kn2==1) {mnu++; if (mnu>2) mnu=0; kn2=0; st1=1; ps2=1;} tx2[3]=0x20; tx2[7]=0x20;
if (mnu==1) {if (kn1==1) {np1++; if (np1>kp1) np1=0; kn1=0; st1=1; vik1(); ps2=1;} if (kn3==1) {np1--; if (np1>kp1) np1=kp1; kn3=0; st1=1; vik1(); ps2=1;} tx2[3]=0xc8; tx2[7]=0x20;}
if (mnu==2) {if (kn1==1) {rg1++; if (rg1>3)   rg1=0; kn1=0; ep1=1; st1=1;  ps2=1;} if (kn3==1) {rg1--; if (rg1>3)   rg1=3;   kn3=0; ep1=1; st1=1;  ps2=1;} tx2[3]=0x20; tx2[7]=0xc8;}
bytetostr(np1+1,tx1); tx2[0]=0x20;tx2[1]=tx1[1];tx2[2]=tx1[2];
if ((kp1>99) && (rg1!=4)) {rg1=3; np1=0; tx2[1]=0x20; tx2[2]=0x30;} if (ep1==1) {eeprom_write(0x00,rg1); ep1=0; vik1();}
tx2[4]=0x20;tx2[5]=rg1;tx2[6]=rg1; if (rg1==4) {tx2[1]=0x20; tx2[2]=0x30; tx2[5]=0xa8; tx2[6]=0x4b; np1=0;} stroka(2);
}

void menu2() //  RGB
{
tx2[0]=0x52;tx2[1]=0x47;tx2[2]=0x42;tx2[3]=0x20;tx2[4]=0x20;tx2[5]=0x52;tx2[6]=0x47;tx2[7]=0x42; stroka(1);
if (kn2==1) {mnu++; if (mnu>5) mnu=3; kn2=0; st1=1; ps2=1;} tx2[3]=0x20; tx2[7]=0x20;
if (mnu==4) {if (kn1==1) {np2++; if (np2>kp2) np2=0; kn1=0; st1=1; vik2(); ps2=1;} if (kn3==1) {np2--; if (np2>kp2) np2=kp2; kn3=0; st1=1; vik2(); ps2=1;} tx2[3]=0xc8; tx2[7]=0x20;}
if (mnu==5) {if (kn1==1) {rg2++; if (rg2>3)   rg2=1; kn1=0; ep1=1; st1=1;  ps2=1;} if (kn3==1) {rg2--; if (rg2==0)  rg2=3;   kn3=0; ep1=1; st1=1;  ps2=1;} tx2[3]=0x20; tx2[7]=0xc8;}
bytetostr(np2+1,tx1); tx2[0]=0x20;tx2[1]=tx1[1];tx2[2]=tx1[2];
if ((kp2>99) && (rg2!=4)) {rg2=3; np2=0; tx2[1]=0x20; tx2[2]=0x30;} if (ep1==1) {eeprom_write(0x01,rg2); ep1=0; vik2();}
tx2[4]=0x20;tx2[5]=rg2;tx2[6]=rg2; if (rg2==4) {tx2[1]=0x20; tx2[2]=0x30; tx2[5]=0xa8; tx2[6]=0x4b; np2=0;} stroka(2);
}

void menu3() //  1 
{
tx2[0]=0xa7;tx2[1]=0x31;tx2[2]=0x20;tx2[3]=0x20;tx2[4]=0x20;tx2[5]=0x20;tx2[6]=0xa7;tx2[7]=0x31; stroka(1);
if (kn2==1) {mnu++; if (mnu>8) mnu=6; kn2=0; st1=1; ps2=1;} tx2[3]=0x20; tx2[7]=0x20;
if (mnu==7) {if (kn1==1) {np3++; if (np3>kp3) np3=0; kn1=0; st1=1; vik3(); ps2=1;} if (kn3==1) {np3--; if (np3>kp3) np3=kp3; kn3=0; st1=1; vik3(); ps2=1;} tx2[3]=0xc8; tx2[7]=0x20;}
if (mnu==8) {if (kn1==1) {rg3++; if (rg3>3)   rg3=0; kn1=0; ep1=1; st1=1;  ps2=1;} if (kn3==1) {rg3--; if (rg3>3)   rg3=3;   kn3=0; ep1=1; st1=1;  ps2=1;} tx2[3]=0x20; tx2[7]=0xc8;}
bytetostr(np3+1,tx1); tx2[0]=0x20;tx2[1]=tx1[1];tx2[2]=tx1[2];
if ((kp3>99) && (rg3!=4)) {rg3=3; np3=0; tx2[1]=0x20; tx2[2]=0x30;} if (ep1==1) {eeprom_write(0x02,rg3); ep1=0; vik3();}
tx2[4]=0x20;tx2[5]=rg3;tx2[6]=rg3; if (rg3==4) {tx2[1]=0x20; tx2[2]=0x30; tx2[5]=0xa8; tx2[6]=0x4b; np3=0;} stroka(2);
}

void menu4() //  2 
{
tx2[0]=0xa7;tx2[1]=0x32;tx2[2]=0x20;tx2[3]=0x20;tx2[4]=0x20;tx2[5]=0x20;tx2[6]=0xa7;tx2[7]=0x32; stroka(1);
if (kn2==1)  {mnu++; if (mnu>11) mnu=9; kn2=0; st1=1; ps2=1;} tx2[3]=0x20; tx2[7]=0x20;
if (mnu==10) {if (kn1==1) {np4++; if (np4>kp4) np4=0; kn1=0; st1=1; vik4(); ps2=1;} if (kn3==1) {np4--; if (np4>kp4) np4=kp4; kn3=0; st1=1; vik4(); ps2=1;} tx2[3]=0xc8; tx2[7]=0x20;}
if (mnu==11) {if (kn1==1) {rg4++; if (rg4>3)   rg4=0; kn1=0; ep1=1; st1=1;  ps2=1;} if (kn3==1) {rg4--; if (rg4>3)   rg4=3;   kn3=0; ep1=1; st1=1;  ps2=1;} tx2[3]=0x20; tx2[7]=0xc8;}
bytetostr(np4+1,tx1); tx2[0]=0x20;tx2[1]=tx1[1];tx2[2]=tx1[2];
if ((kp4>99) && (rg4!=4)) {rg4=3; np4=0; tx2[1]=0x20; tx2[2]=0x30;} if (ep1==1) {eeprom_write(0x03,rg4); ep1=0; vik4();}
tx2[4]=0x20;tx2[5]=rg4;tx2[6]=rg4; if (rg4==4) {tx2[1]=0x20; tx2[2]=0x30; tx2[5]=0xa8; tx2[6]=0x4b; np4=0;} stroka(2);
}

void main()
{
adcon1=0x0f; cmcon=0x07; //  
intcon=0xa0; //   0
t0con=0xc0; tmr0l=154; rgb1=0; //0 8 
intcon2=0x80; //     B
porta=0x07; trisa=0x00; portb=0x28; trisb=0x80; portc=0x00; trisc=0x01; portd=0x00; trisd=0x00; porte=0x00; trise=0x08;
indin(); // 
i2c1_init(100000); //  i2c
hid_enable(&ru,&wu); // HID 
gr1=0; mg1=1000; mg2=1000; mg3=1000; mg4=1000; mv1=0; mv2=0; mv3=0; mv4=0;
ms1=0; mnu=0; np1=0; np2=0; np3=0; np4=0; ps1=0; rr1=0; gg1=0; bb1=0; rr2=0; gg2=0; bb2=0; ru[0]=100; ms2=0; yr2=0;
dd1[0]=0; dd1[1]=0; dd1[2]=0; dd2[0]=0; dd2[1]=0; dd2[2]=0; wu[0]=0; wu[1]=0; wu[2]=0; wu[3]=0;
sh1=0; sh2=0; sh3=0; sh4=0; pp1=0; pp2=0; pp3=0; pp4=0;
kn1=0; kn2=0; kn3=0; ep1=0; st1=1; ps2=1; vk1=1; vk2=1; vk3=1; vk4=1; v12=1;
rg1=eeprom_read(0x00); rg2=eeprom_read(0x01); rg3=eeprom_read(0x02); rg4=eeprom_read(0x03);
do
{
usb_polling_proc(); //    USB

if (ms1>50) // 1     
{
ms1=0; ms2++; hid_read();
if ((ru[0]==1) && (ru[1]==1)) {gr1=(ru[3]<<8)+ru[2]; yr2=100-ru[4]; vklg(); if (rg1!=4) {mnu=0; st1=1; rg1=4; ps2=1;}}           //   
if ((ru[0]==2) && (ru[1]==2)) {rr2=ru[2]; gg2=ru[3]; bb2=ru[4]; if (rg2!=4) {mnu=3; st1=1; rg2=4; ps2=1;}}                       //   RGB 
if ((ru[0]==3) && (ru[1]==3)) {dd1[0]=ru[2]; dd1[1]=ru[3]; dd1[2]=ru[4]; v12=1; if (rg3!=4) {mnu=6; st1=1; rg3=4; ps2=1;}}       //   1 
if ((ru[0]==4) && (ru[1]==4)) {dd2[0]=ru[2]; dd2[1]=ru[3]; dd2[2]=ru[4]; v12=1; if (rg4!=4) {mnu=9; st1=1; rg4=4; ps2=1;}}       //   2 
if ((ru[0]==5) && (ru[1]==5)) {vik1(); vik2(); vik3(); vik4(); wu[0]=24; wu[1]=24; wu[2]=0; wu[3]=0; hid_write(&wu,64); chtn();} //   EEPROM  
if ((ru[0]==6) && (ru[1]==6)) {vik1(); vik2(); vik3(); vik4(); wu[0]=12; wu[1]=12; wu[2]=0; wu[3]=0; hid_write(&wu,64); zaps();} //     EEPROM
ru[0]=100;

if (ms2>100) //100 
{
asm clrwdt; //   ( 2    ,   )
ms2=0; but(); ps1++; if (portc.b6==0 && (kn1==1 || kn2==1 || kn3==1)) {kn1=0; kn2=0; kn3=0; ps2=1; st1=1;}

if (mnu==0 || mnu==3 || mnu==6 || mnu==9)
{
if (kn1==1) {mnu=mnu+3; if (mnu>9) mnu=0; kn1=0; st1=1; ps2=1;}
if (kn2==1) {mnu++; kn2=0; st1=1; ps2=1;}
if (kn3==1) {mnu=mnu-3; if (mnu>9) mnu=9; kn3=0; st1=1; ps2=1;}
}

if (mnu<3) menu1(); if (mnu>2 && mnu<6) menu2(); if (mnu>5 && mnu<9) menu3(); if (mnu>8) menu4(); st1=0; rgb1=1;
if (ps2==1) {portc.b6=1; ps1=0; ps2=0;} if (ps1>100) {portc.b6=0; ps1=0; hid_write(&wu,64); indwr(0x01,0);} ///  
}

if (vk1==1) {delay_ms(10); eepromr(np1*128,0);       vk1=0; kp1=dt1[7]; if (np1>kp1) np1=0; if (kp1>99) {rg1=3; st1=1;}} //   
if (vk2==1) {delay_ms(10); eepromr(np2*128+6400,1);  vk2=0; kp2=dt2[7]; if (np2>kp2) np2=0; if (kp2>99) {rg2=3; st1=1;}} //   RGB 
if (vk3==1) {delay_ms(10); eepromr(np3*192+12800,2); vk3=0; kp3=dt3[7]; if (np3>kp3) np3=0; if (kp3>99) {rg3=3; st1=1;}} //   1 
if (vk4==1) {delay_ms(10); eepromr(np4*192+22400,3); vk4=0; kp4=dt4[7]; if (np4>kp4) np4=0; if (kp4>99) {rg4=3; st1=1;}} //   2 

/// 
if (rg1==0) {gr1=1023; vklg();}
if ((rg1==1) || (rg1==2))
{
if (pp1==dt1[sh1*8+5]) {if (rg1==1) np1++; if (np1>kp1) np1=0; eepromr(np1*128,0); pp1=0; sh1=0;}
if (mg1>mv1) {i1=sh1*8; gr1=(dt1[i1+1]<<8)+dt1[i1]; yr2=100-dt1[i1+2]; mv1=(dt1[i1+4]<<8)+dt1[i1+3]; vklg(); sh1++; mg1=0; if (sh1>15) {sh1=0; pp1++;}}
}
if (rg1==3) {gr1=0; vklg();}


/// RGB 
if ((rg2==1) || (rg2==2))
{
if (pp2==dt2[sh2*8+5]) {if (rg2==1) np2++; if (np2>kp2) np2=0; eepromr(np2*128+6400,1); pp2=0; sh2=0;}
if (mg2>mv2) {i1=sh2*8; rr2=dt2[i1]; gg2=dt2[i1+1]; bb2=dt2[i1+2]; mv2=(dt2[i1+4]<<8)+dt2[i1+3]; sh2++; mg2=0; if (sh2>15) {sh2=0; pp2++;}}
}
if (rg2==3) {rr2=100; gg2=100; bb2=100;}


/// 1 
if (rg3==0) {dd1[0]=255; dd1[1]=255; dd1[2]=255;}
if ((rg3==1) || (rg3==2))
{
if (pp3==dt3[5]) {if (rg3==1) np3++; if (np3>kp3) np3=0; eepromr(np3*192+12800,2); pp3=0; sh3=0;}
if (mg3>mv3) {i1=sh3*8; dd1[2]=dt3[i1]; dd1[1]=dt3[i1+1]; dd1[0]=dt3[i1+2]; mv3=dt3[4]*250; v12=1; sh3++; mg3=0; if (sh3>23) {sh3=0; pp3++;}}
}
if (rg3==3) {dd1[0]=0; dd1[1]=0; dd1[2]=0;}


/// 2 
if (rg4==0) {dd2[0]=255; dd2[1]=255; dd2[2]=255;}
if ((rg4==1) || (rg4==2))
{
if (pp4==dt4[5]) {if (rg4==1) np4++; if (np4>kp4) np4=0; eepromr(np4*192+22400,3); pp4=0; sh4=0;}
if (mg4>mv4) {i1=sh4*8; dd2[2]=dt4[i1]; dd2[1]=dt4[i1+1]; dd2[0]=dt4[i1+2]; mv4=dt4[4]*250; v12=1; sh4++; mg4=0; if (sh4>23) {sh4=0; pp4++;}}
}
if (rg4==3) {dd2[0]=0; dd2[1]=0; dd2[2]=0;}


if (v12==1) {vkl12(); v12=0;} //     
mg1++; mg2++; mg3++; mg4++; //   , RGB   
}

}
while(1);
}